#include "testlib.h"
#include <bits/stdc++.h>

using namespace std;

int MAXC = 1e6;

int gcd(int x, int y) {
    if (y == 0) {
        return x;
    }
    return gcd(y, x % y);
}

pair<int, int> makeDir(pair<int, int> d) {
    if (d.first == 0 && d.second == 0) {
        return d;
    }

    d = min(d, make_pair(-d.first, -d.second));
    int g = gcd(abs(d.first), abs(d.second));
    d.first /= g;
    d.second /= g;
    return {d.first, d.second};
}

pair<int, int> coeffs(int mn, int mx, int x) {
    if (x == 0) {
        return {-MAXC, MAXC};
    }
    pair<int, int> ans(mn / x, mx / x);
    if (ans.first > ans.second) {
        swap(ans.first, ans.second);
    }
    return ans;
}

int main(int argc, char **argv) {
    registerGen(argc, argv, 1);
    int x0 = 0;
    int y0 = 0;
    int n = atoi(argv[1]);
    int c = atof(argv[2]);
    set<pair<int, int> > dirs;
    dirs.emplace(0, 0);

    vector<pair<int, int> > points;

    int badId = rnd.next(0, n - 1);

    for (int i = 0; i < n; i++) {
        int cx = 0, cy = 0;
        while (dirs.count(makeDir({cx, cy}))) {
            cx = rnd.next(-c, c);
            cy = rnd.next(-c, c);
        }
        auto dir = makeDir({cx, cy});
        dirs.emplace(dir);
        int dx, dy;
        tie(dx, dy) = dir;
        auto cox = coeffs(-c - x0, c - x0, dx);
        auto coy = coeffs(-c - y0, c - y0, dy);
        pair<int, int> seg(max(cox.first, coy.first), min(cox.second, coy.second));
        set<int> muls;
        int cnt = 2;
        if (i == badId) {
            cnt = 4;
        }
        for (int i = 0; i < cnt; i++) {
            int mul = 0;
            while (mul == 0 || muls.count(mul)) {
                mul = rnd.next(seg.first, seg.second);
            }
            muls.insert(mul);
        }
        for (int x : muls) {
            points.emplace_back(dx * x, dy * x);
        }
    }
    shuffle(points.begin(), points.end());
    cout << n << endl;
    for (const auto& pt : points) {
        cout << x0 + pt.first << " " << y0 + pt.second << endl;
    }
    return 0;
}

